# coding: utf-8

"""
    Intrinio API

    Welcome to the Intrinio API! Through our Financial Data Marketplace, we offer a wide selection of financial data feed APIs sourced by our own proprietary processes as well as from many data vendors. For a complete API request / response reference please view the [Intrinio API documentation](https://intrinio.com/documentation/api_v2). If you need additional help in using the API, please visit the [Intrinio website](https://intrinio.com) and click on the chat icon in the lower right corner.  # noqa: E501

    OpenAPI spec version: 2.5.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from intrinio_sdk.models.crypto_exchange_summary import CryptoExchangeSummary  # noqa: F401,E501
from intrinio_sdk.models.crypto_pair_summary import CryptoPairSummary  # noqa: F401,E501
from intrinio_sdk.models.crypto_snapshot import CryptoSnapshot  # noqa: F401,E501


class ApiResponseCryptoSnapshot(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'pair': 'CryptoPairSummary',
        'exchange': 'CryptoExchangeSummary',
        'snapshot': 'CryptoSnapshot'
    }

    attribute_map = {
        'pair': 'pair',
        'exchange': 'exchange',
        'snapshot': 'snapshot'
    }

    def __init__(self, pair=None, exchange=None, snapshot=None):  # noqa: E501
        """ApiResponseCryptoSnapshot - a model defined in Swagger"""  # noqa: E501

        self._pair = None
        self._exchange = None
        self._snapshot = None
        self.discriminator = None

        if pair is not None:
            self.pair = pair
        if exchange is not None:
            self.exchange = exchange
        if snapshot is not None:
            self.snapshot = snapshot

    @property
    def pair(self):
        """Gets the pair of this ApiResponseCryptoSnapshot.  # noqa: E501


        :return: The pair of this ApiResponseCryptoSnapshot.  # noqa: E501
        :rtype: CryptoPairSummary
        """
        return self._pair
        
    @property
    def pair_dict(self):
        """Gets the pair of this ApiResponseCryptoSnapshot.  # noqa: E501


        :return: The pair of this ApiResponseCryptoSnapshot.  # noqa: E501
        :rtype: CryptoPairSummary
        """

        result = None

        value = self.pair
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'pair': value }

        
        return result
        

    @pair.setter
    def pair(self, pair):
        """Sets the pair of this ApiResponseCryptoSnapshot.


        :param pair: The pair of this ApiResponseCryptoSnapshot.  # noqa: E501
        :type: CryptoPairSummary
        """

        self._pair = pair

    @property
    def exchange(self):
        """Gets the exchange of this ApiResponseCryptoSnapshot.  # noqa: E501


        :return: The exchange of this ApiResponseCryptoSnapshot.  # noqa: E501
        :rtype: CryptoExchangeSummary
        """
        return self._exchange
        
    @property
    def exchange_dict(self):
        """Gets the exchange of this ApiResponseCryptoSnapshot.  # noqa: E501


        :return: The exchange of this ApiResponseCryptoSnapshot.  # noqa: E501
        :rtype: CryptoExchangeSummary
        """

        result = None

        value = self.exchange
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'exchange': value }

        
        return result
        

    @exchange.setter
    def exchange(self, exchange):
        """Sets the exchange of this ApiResponseCryptoSnapshot.


        :param exchange: The exchange of this ApiResponseCryptoSnapshot.  # noqa: E501
        :type: CryptoExchangeSummary
        """

        self._exchange = exchange

    @property
    def snapshot(self):
        """Gets the snapshot of this ApiResponseCryptoSnapshot.  # noqa: E501


        :return: The snapshot of this ApiResponseCryptoSnapshot.  # noqa: E501
        :rtype: CryptoSnapshot
        """
        return self._snapshot
        
    @property
    def snapshot_dict(self):
        """Gets the snapshot of this ApiResponseCryptoSnapshot.  # noqa: E501


        :return: The snapshot of this ApiResponseCryptoSnapshot.  # noqa: E501
        :rtype: CryptoSnapshot
        """

        result = None

        value = self.snapshot
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'snapshot': value }

        
        return result
        

    @snapshot.setter
    def snapshot(self, snapshot):
        """Sets the snapshot of this ApiResponseCryptoSnapshot.


        :param snapshot: The snapshot of this ApiResponseCryptoSnapshot.  # noqa: E501
        :type: CryptoSnapshot
        """

        self._snapshot = snapshot

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApiResponseCryptoSnapshot):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
